/*
	borhelp.h
*/

#ifndef __BORHELP_H__
#define __BORHELP_H__

typedef unsigned char	bh_byte;
typedef unsigned short	bh_word;
typedef unsigned long	bh_dword;

#define BH_SIGNATURE	"$*$* &&&&$*$"

typedef struct {
	bh_byte		format_version;
	bh_byte		text_version;
} bh_version;

typedef struct {
	bh_byte		rec_type;
	bh_word		length;
} bh_rechdr;

#define RT_FILEHEADER	0
#define RT_CONTEXT		1
#define RT_TEXT			2
#define RT_KEYWORD		3
#define RT_INDEX		4
#define RT_COMPRESSION	5

typedef struct {
	bh_word		options;
	bh_word		main_idx;
	bh_word		max_screen_size;
	bh_byte		height;
	bh_byte		width;
	bh_byte		margin_left;
} bh_filehdr;

typedef struct {
	bh_byte		method;
	bh_byte		table[14];
} bh_comprec;

#define METHOD_NONE		0
#define METHOD_RLE		1
#define METHOD_NIBBLE	2

#define NIBBLE_LITERAL	0xf
#define NIBBLE_REPEAT	0xe

typedef struct {
	bh_word		count;
	bh_byte		offset[3];
} bh_context;

#define CONTEXT_INDEX	( (-1L) & (0xffffffL))
#define CONTEXT_DONTUSE	( (-2L) & (0xffffffL))


#endif
